Subject: bug#16366: closed (Re: bug#16366: 24.3.50; [PATCH] GDB Registers buffer - wrong values fontified)

From: [email-masked] (GNU bug Tracking System)
Date: Wed, 26 Jun 2019 16:19:02 +0000

Your bug report

#16366: 24.3.50; [PATCH] GDB Registers buffer - wrong values fontified

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
16366: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=16366
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#16366: 24.3.50; [PATCH] GDB Registers buffer - wrong values fontified
From: Eli Zaretskii <[email-masked]>
To: Lars Ingebrigtsen <[email-masked]>
Cc: [email-masked], [email-masked]
Date: Wed, 26 Jun 2019 19:17:53 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

> From: Lars Ingebrigtsen <[email-masked]>
> Date: Wed, 26 Jun 2019 16:55:43 +0200
> Cc: [email-masked]
> 
> >  $ emacs -Q
> >
> >  M-x gdb
> >
> >  gdb -i=mi emacs <return> (or something suitable)
> >
> >  M-x gdb-display-registers-buffer
> >
> > In GUD buffer:
> >
> >  (gdb) break main
> >  (gdb) run
> >
> > Now step by machine instructions (e.g. 'C-x C-a C-i').  The values of
> > registers in the Registers buffer change but are fontified only on the
> > following step.
> 
> I tried to reproduce this, but all I got was a bunch of
> 
> Breakpoint 3, main (argc=1, argv=0x7fffffffe9e8) at emacs.c:977
> 977	{
> (gdb) Python Exception <class 'NameError'> name 'long' is not defined: 
> Python Exception <class 'NameError'> name 'long' is not defined: 
> Python Exception <class 'NameError'> name 'long' is not defined: 
> Python Exception <class 'NameError'> name 'long' is not defined: 

Your GDB seems to be misconfigured wrt its Python extensions.

I've reproduced the problem, verified that the proposed patch fixes
it, and installed it on the master branch.

Andrzej, apologies for such a long delay in fixing this simple
problem, and thanks for the patch.

Subject: 24.3.50; [PATCH] GDB Registers buffer - wrong values fontified
From: Andrzej P <[email-masked]>
To: [email-masked]
Date: Mon, 06 Jan 2014 00:35:04 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

When stepping through a program with the GDB graphical interface, the
values in the Registers buffer are fontified with
'font-lock-warning-face' on the step *after* they have changed.  It
makes more sense to highlight changed values on each step.  I guess
that this is a bug.

To reproduce:

 $ emacs -Q

 M-x gdb

 gdb -i=mi emacs <return> (or something suitable)

 M-x gdb-display-registers-buffer

In GUD buffer:

 (gdb) break main
 (gdb) run
 
Now step by machine instructions (e.g. 'C-x C-a C-i').  The values of
registers in the Registers buffer change but are fontified only on the
following step.

The reason is that in 'gdb-update', 'gdb-changed-registers' is updated
*after* the buffers are updated.  Switching the order of the two
operations as in the following patch solves the problem.  

=== modified file 'lisp/progmodes/gdb-mi.el'
--- lisp/progmodes/gdb-mi.el	2014-01-01 07:43:34 +0000
+++ lisp/progmodes/gdb-mi.el	2014-01-05 23:08:27 +0000
@@ -1890,10 +1890,11 @@
   ;; gdb-break-list is maintained in breakpoints handler
   (gdb-get-buffer-create 'gdb-breakpoints-buffer)
 
+  (gdb-get-changed-registers)
+
   (unless no-proc
     (gdb-emit-signal gdb-buf-publisher 'update))
 
-  (gdb-get-changed-registers)
   (when (and (boundp 'speedbar-frame) (frame-live-p speedbar-frame))
     (dolist (var gdb-var-list)
       (setcar (nthcdr 5 var) nil))

In GNU Emacs 24.3.50.3 (x86_64-unknown-linux-gnu, GTK+ Version 3.4.2)
 of 2014-01-05 on andrzej-laptop
Bzr revision: 115879 [email-masked]
Windowing system distributor `The X.Org Foundation', version 11.0.11103000
System Description:	Trisquel 6.0

Important settings:
  value of $LC_MONETARY: en_GB.UTF-8
  value of $LC_NUMERIC: en_GB.UTF-8
  value of $LC_TIME: en_GB.UTF-8
  value of $LANG: en_GB.UTF-8
  locale-coding-system: utf-8-unix

Major mode: Lisp Interaction

Minor modes in effect:
  tooltip-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Recent input:
M-x r e p o r t SPC e m <tab> <return>

Recent messages:
For information about GNU Emacs and the GNU system, type C-h C-a.

Load-path shadows:
None found.

Features:
(shadow sort gnus-util mail-extr emacsbug message format-spec rfc822 mml
easymenu mml-sec mm-decode mm-bodies mm-encode mail-parse rfc2231
mailabbrev gmm-utils mailheader sendmail rfc2047 rfc2045 ietf-drums
mm-util help-fns mail-prsvr mail-utils time-date tooltip electric
uniquify ediff-hook vc-hooks lisp-float-type mwheel x-win x-dnd tool-bar
dnd fontset image regexp-opt fringe tabulated-list newcomment lisp-mode
prog-mode register page menu-bar rfn-eshadow timer select scroll-bar
mouse jit-lock font-lock syntax facemenu font-core frame cham georgian
utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao korean
japanese hebrew greek romanian slovak czech european ethiopic indian
cyrillic chinese case-table epa-hook jka-cmpr-hook help simple abbrev
minibuffer nadvice loaddefs button faces cus-face macroexp files
text-properties overlay sha1 md5 base64 format env code-pages mule
custom widget hashtable-print-readable backquote make-network-process
dbusbind gfilenotify dynamic-setting system-font-setting
font-render-setting move-toolbar gtk x-toolkit x multi-tty emacs)